PROGRAM_NAME='debug lib example'
(***********************************************************)
(*  FILE CREATED ON: 03/21/2002 AT: 00:00:00               *)
(***********************************************************)
(*  FILE_LAST_MODIFIED_ON: 08/28/2012  AT: 16:25:19        *)
(***********************************************************)
(*  FILE REVISION: 3.02                                    *)
(*  REVISION DATE: 08/28/2012  AT: 15:29:37                *)
(*                                                         *)
(*  COMMENTS:                                              *)
(*  - Now using the new functions in DEV_TO_STRING.axi and *)
(*    debug.axi v3.xx.                                     *)
(*                                                         *)
(***********************************************************)
(*  FILE REVISION: 2.51                                    *)
(*  REVISION DATE: 01/05/2010  AT: 11:44:02                *)
(*                                                         *)
(*  COMMENTS:                                              *)
(*  - DEV_TO_STRING() and related subroutines have been    *)
(*    moved to the new DEV_TO_STRING.axi.                  *)
(*    Debug.axi v2.53 and above has an include statement   *)
(*    for the new axi, so old code does not have to be     *)
(*    updated. But...                                      *)
(*  - Be sure to add the DEV_TO_STRING.axi to Studio       *)
(*    projects and and workspaces where necessary,         *)
(*    when using debug.axi v2.53 or later.                 *)
(*  - AXI versions:                                        *)
(*      DEV_TO_STRING.axi v2.55                            *)
(*      debug.axi v2.57                                    *)
(*                                                         *)
(***********************************************************)
(*!!FILE REVISION: 2.01                                    *)
(*  REVISION DATE: 02/01/2005                              *)
(*                                                         *)
(*  COMMENTS:                                              *)
(*    - debug.axi v2.01.                                   *)
(*    - added more examples.                               *)
(***********************************************************)
(*!!FILE REVISION: 1.03                                    *)
(*  REVISION DATE: 05/29/2003                              *)
(*                                                         *)
(*  COMMENTS:                                              *)
(*    - remove GET_LAST example as it doesn't really       *)
(*      belong here.                                       *)
(*    - add examples of 'SEND DECIMAL..', 'SEND 7BIT...'.  *)
(***********************************************************)
(*!!FILE REVISION:                                         *)
(*  REVISION DATE: 05/24/2002                              *)
(*                                                         *)
(*  COMMENTS:                                              *)
(*    - in terminal type                                   *)
(*      MSG ON<enter>                                      *)
(*      then                                               *)
(*      SEND C 33000,'HELP'<enter>                         *)
(*      then try some of the commands in the help list.    *)
(*                                                         *)
(*    - EXAMPLES OF:                                       *)
/*  1   FUNCTION CHAR[17] DEV_TO_STRING (DEV dvDEV)                           */
/*  2   FUNCTION CHAR[25] DEVCHAN_TO_STRING (DEVCHAN dcDC)                    */
/*  3   FUNCTION CHAR[25] DEV_CHAN_TO_STRING (DEV dvDEV, INTEGER nCH)         */
/*  4   FUNCTION CHAR[25] DEVLEV_TO_STRING (DEVLEV dlDL)                      */
/*  7   FUNCTION          STRING_TO_DEV (sDEV[],dvDEV)                        */
/* 11   FUNCTION printDEVICE_INFO (DEV dvDEBUG, CHAR hdr[], DEV dvDEV)        */
/* 12   FUNCTION printToDebug (DEV dvDEBUG,STR1[],STR2[],nLine,nMode,nFormat) */

/* The old calls are just wrappers now, included for compatibilitiy:          */
/*  7   CALL 'SEND 131 BYTE PACKETS TO MASTER' (sSTRING[])                    */
/*  8   CALL 'SEND 7BIT ASCII TO DEBUG' (DEV dvDEBUG,STR1[],STR2[],nLine,nMode)*/
/*  9   CALL 'SEND ASCII TO DEBUG' (DEV dvDEBUG,STR1[],STR2[],nLine,nMode)    */
/* 10   CALL 'SEND ASCII TO MASTER' (STR1[],STR2[])                           */
/* 11   CALL 'SEND DECIMAL TO DEBUG' (DEV dvDEBUG,STR1[],STR2[],nLine,nMode)  */
/* 12   CALL 'SEND DEVICE_INFO TO DEBUG' (DEV dvDEBUG, DEV dvDEV)             */
/* 14   CALL 'SEND ITOHEX TO DEBUG' (DEV dvDEBUG,STR1[],STR2[],nLine,nMode)   */
/* 15   CALL 'SEND ITOHEX TO MASTER' (STR1[],STR2[])                          */
/* 16   CALL 'STRING TO DEV' (sDEV[],dvDEV)                                   */
(***********************************************************)
#INCLUDE 'DEV_TO_STRING.axi'
#INCLUDE 'debug.axi'
(***********************************************************)
(*          DEVICE NUMBER DEFINITIONS GO BELOW             *)
(***********************************************************)
DEFINE_DEVICE

dvDEBUG     = 0:0:0

dvTP        = 10002:2:0

dvRS232     = 5001:1:0
dvRELAY     = 5001:8:0

vdvCONTROL  = 32999:1:0

vdvDEBUG    = 33001:1:0

(***********************************************************)
(*               CONSTANT DEFINITIONS GO BELOW             *)
(***********************************************************)
DEFINE_CONSTANT

__PROGRAM_VERSION__ = '3.02'

DEVCHAN dcPUSH_TP1[] =
{
  {dvTP, 1},{dvTP, 2},{dvTP, 3},{dvTP, 4},
  {dvTP, 5},{dvTP, 6},{dvTP, 7},{dvTP, 8},
  {dvTP, 9},{dvTP,10},{dvTP,11},{dvTP,12}
}

DEVCHAN dcFUNC_RELAY[] =
{
  {dvRELAY, 1},{dvRELAY, 5},{dvRELAY, 9},
  {dvRELAY, 2},{dvRELAY, 6},{dvRELAY,10},
  {dvRELAY, 3},{dvRELAY, 7},{dvRELAY,11},
  {dvRELAY, 4},{dvRELAY, 8},{dvRELAY,12}
}

DEVLEV dlTP[] =
{
  {dvTP,1},{dvTP,2},{dvTP,3},{dvTP,4},{dvTP,5},{dvTP,6},{dvTP,7},{dvTP,8}
}

(***********************************************************)
(*              DATA TYPE DEFINITIONS GO BELOW             *)
(***********************************************************)
DEFINE_TYPE

(***********************************************************)
(*               VARIABLE DEFINITIONS GO BELOW             *)
(***********************************************************)
DEFINE_VARIABLE

INTEGER X
CHAR sARRAY[256]
CHAR sASCII[256]

(***********************************************************)
(*               LATCHING DEFINITIONS GO BELOW             *)
(***********************************************************)
DEFINE_LATCHING

(***********************************************************)
(*       MUTUALLY EXCLUSIVE DEFINITIONS GO BELOW           *)
(***********************************************************)
DEFINE_MUTUALLY_EXCLUSIVE

(***********************************************************)
(*        SUBROUTINE/FUNCTION DEFINITIONS GO BELOW         *)
(***********************************************************)
(* EXAMPLE: DEFINE_FUNCTION <RETURN_TYPE> <NAME> (<PARAMETERS>) *)
(* EXAMPLE: DEFINE_CALL '<NAME>' (<PARAMETERS>) *)

(***********************************************************)
(*                STARTUP CODE GOES BELOW                  *)
(***********************************************************)
DEFINE_START

(* System Information Strings ******************************)
(* Use this section if there is a TP in the System!        *)
(*
    SEND_COMMAND TP,"'!F',250,'1'"
    SEND_COMMAND TP,"'TEXT250-',__NAME__"
    SEND_COMMAND TP,"'!F',251,'1'"
    SEND_COMMAND TP,"'TEXT251-',__FILE__,', ',S_DATE,', ',S_TIME"
    SEND_COMMAND TP,"'!F',252,'1'"
    SEND_COMMAND TP,"'TEXT252-',__VERSION__"
    SEND_COMMAND TP,"'!F',253,'1'"
    (* Must fill this (Master Ver) *)
    SEND_COMMAND TP,'TEXT253-'
    SEND_COMMAND TP,"'!F',254,'1'"
    (* Must fill this (Panel File) *)
    SEND_COMMAND TP,'TEXT254-'
    SEND_COMMAND TP,"'!F',255,'1'"
    (* Must fill this (Dealer Info) *)
    SEND_COMMAND TP,'TEXT255-'
*)
(***********************************************************)
(*                THE EVENTS GOES BELOW                    *)
(***********************************************************)
DEFINE_EVENT

// DEVCHAN_TO_STRING EXAMPLE
BUTTON_EVENT[dvTP,0]                // 0 = ALL CHANNELS
{
  PUSH:
  {
	STACK_VAR nRelay
    SEND_STRING 0,"'PUSH',DEVCHAN_TO_STRING(BUTTON.INPUT)"

	// code to toggle the relays
	nRelay = BUTTON.INPUT.CHANNEL%8
	IF (!nRelay) { nRelay = 8 }

	[dvRELAY,nRelay] = ![dvRELAY,nRelay]
  }
  RELEASE:
  {
    SEND_STRING 0,"'RELEASE',DEVCHAN_TO_STRING(BUTTON.INPUT)"
  }
  HOLD[5,REPEAT]:
  {
    SEND_STRING 0,"'HOLD',DEVCHAN_TO_STRING(BUTTON.INPUT),FORMAT(' TIME %d',BUTTON.HOLDTIME)"
  }
}

// DEV_CHAN_TO_STRING EXAMPLE
CHANNEL_EVENT[dvRELAY,0]            // 0 = ALL CHANNELS
{
  ON:
  {
    SEND_STRING 0,"'ON',DEV_CHAN_TO_STRING(CHANNEL.DEVICE,CHANNEL.CHANNEL)"
  }
  OFF:
  {
    SEND_STRING 0,"'OFF',DEV_CHAN_TO_STRING(CHANNEL.DEVICE,CHANNEL.CHANNEL)"
  }
}

// DEVLEV_TO_STRING EXAMPLE
LEVEL_EVENT[dlTP]
{
  SEND_STRING 0,"DEVLEV_TO_STRING(LEVEL.INPUT),' = ',ITOA(LEVEL.VALUE)"
}

// PROGRAM CONTROL DEVICE
DATA_EVENT[vdvCONTROL]
{
  ONLINE:
  {
                                    // populate the binary test string
    FOR (X = 0; X < 256; X++) {
      sARRAY = "sARRAY,x"
    }
                                    // populate the ASCII test string
    FOR (X = 1; X < 256; X++) {
      sASCII = "sASCII,((X % 94) + 33)"
    }
  }
                                    // Terminal command tests
  COMMAND:                          // SEND C <device num:port:sys>,'<command>'<enter>
  {
	STACK_VAR DEV     dvInfo        // dev for 'SEND DI <dev>' test
	STACK_VAR CHAR    CMD[32]

	IF (FIND_STRING(DATA.TEXT,'-',1)) { CMD = UPPER_STRING(REMOVE_STRING(DATA.TEXT,'-',1)) }
	ELSE                              { CMD = UPPER_STRING(LEFT_STRING(DATA.TEXT,MAX_LENGTH_ARRAY(CMD))) }

    SWITCH (CMD)
    {
      CASE 'VER':
      {
        SEND_STRING 0,"__NAME__,' v',__PROGRAM_VERSION__"
      }
	  // DEV_TO_STRING example
      CASE 'HELP':
      {
        SEND_STRING 0,"13,10"
        SEND_STRING 0,"'Help ',DEV_TO_STRING(DATA.DEVICE),' -- Commands Available:'"
        SEND_STRING 0,"'  SEND 131'"
        SEND_STRING 0,"'  SEND ASC'"
        SEND_STRING 0,"'  SEND HEX'"
		SEND_STRING 0,"'  SEND DEVICE_INFO'"
		SEND_STRING 0,"'  SEND DI-<dev>'"
        SEND_STRING 0,"'  DEBUG ASC'"
        SEND_STRING 0,"'  DEBUG HEX'"
        SEND_STRING 0,"'  DEBUG DEC'"
        SEND_STRING 0,"'  DEBUG 7BIT'"
		SEND_STRING 0,"'  DEBUG INT'"

        SEND_STRING 0,"'  VER'"
      }
      // 'SEND 131 BYTE PACKETS TO MASTER' EXAMPLE
      CASE 'SEND 131':
      {
        SEND_STRING 0,"13,10"
//        CALL 'SEND 131 BYTE PACKETS TO MASTER' (sARRAY)
//        CALL 'SEND 131 BYTE PACKETS TO MASTER' (sASCII)
        printToDebug (dvDEBUG,"",sARRAY,131,0,PRINT_UNFORMATTED)
        printToDebug (dvDEBUG,"",sASCII,131,0,PRINT_UNFORMATTED)

      }
      // 'SEND ASCII TO MASTER' EXAMPLE
	  // DEV_TO_STRING EXAMPLE
      CASE 'SEND ASC':
      {
        SEND_STRING 0,"13,10"
//        CALL 'SEND ASCII TO MASTER' ("DEV_TO_STRING(DATA.DEVICE),' ARRAY: '",sARRAY)
//        CALL 'SEND ASCII TO MASTER' ("DEV_TO_STRING(DATA.DEVICE),' ASCII: '",sASCII)
        printToDebug (dvDEBUG,"DEV_TO_STRING(DATA.DEVICE),' ARRAY: '",sARRAY,0,0,PRINT_ASCII_EXT)
        printToDebug (dvDEBUG,"DEV_TO_STRING(DATA.DEVICE),' ASCII: '",sASCII,0,0,PRINT_ASCII_EXT)

      }
      // 'SEND ITOHEX TO MASTER' EXAMPLE
	  // DEV_TO_STRING EXAMPLE
      CASE 'SEND HEX':
      {
        SEND_STRING 0,"13,10"
//        CALL 'SEND ITOHEX TO MASTER' ("DEV_TO_STRING(DATA.DEVICE),' ARRAY: '",sARRAY)
//        CALL 'SEND ITOHEX TO MASTER' ("DEV_TO_STRING(DATA.DEVICE),' ASCII: '",sASCII)
		printToDebug (dvDEBUG,"DEV_TO_STRING(DATA.DEVICE),' ARRAY: '",sARRAY,0,0,PRINT_HEX)
        printToDebug (dvDEBUG,"DEV_TO_STRING(DATA.DEVICE),' ASCII: '",sASCII,0,0,PRINT_HEX)
      }
	  // 'SEND DEVICE_INFO TO DEBUG' EXAMPLE
      CASE 'SEND DEVICE_INFO':
      {
//        SEND_STRING 0,"13,10"
//		CALL 'SEND DEVICE_INFO TO DEBUG' (dvDEBUG,DATA.DEVICE)
//        SEND_STRING 0,"13,10"
//		CALL 'SEND DEVICE_INFO TO DEBUG' (dvDEBUG,128:1:0)
//        SEND_STRING 0,"13,10"
//		CALL 'SEND DEVICE_INFO TO DEBUG' (dvDEBUG,301:1:0)
//        SEND_STRING 0,"13,10"
//	    CALL 'SEND DEVICE_INFO TO DEBUG' (dvDEBUG,5001:1:0)
//        SEND_STRING 0,"13,10"
//	    CALL 'SEND DEVICE_INFO TO DEBUG' (dvDEBUG,10001:1:0)
//		SEND_STRING 0,"13,10"
//	    CALL 'SEND DEVICE_INFO TO DEBUG' (dvDEBUG,10002:1:0)
//		SEND_STRING 0,"13,10"
//	    CALL 'SEND DEVICE_INFO TO DEBUG' (dvDEBUG,33000:1:0)
        SEND_STRING 0,"13,10"
		printDEVICE_INFO (dvDEBUG,"",DATA.DEVICE)
        SEND_STRING 0,"13,10"
		printDEVICE_INFO (dvDEBUG,"",128:1:0)
        SEND_STRING 0,"13,10"
		printDEVICE_INFO (dvDEBUG,"",301:1:0)
        SEND_STRING 0,"13,10"
	    printDEVICE_INFO (dvDEBUG,"",5001:1:0)
        SEND_STRING 0,"13,10"
	    printDEVICE_INFO (dvDEBUG,"",10001:1:0)
		SEND_STRING 0,"13,10"
	    printDEVICE_INFO (dvDEBUG,"",10002:1:0)
		SEND_STRING 0,"13,10"
	    printDEVICE_INFO (dvDEBUG,"",33000:1:0)

      }
	  // 'STRING TO DEV' EXAMPLE
	  // 'SEND DEVICE_INFO TO DEBUG' EXAMPLE
	  CASE 'SEND DI-':
      {
		//CALL 'STRING TO DEV' (DATA.TEXT,dvInfo)
		STRING_TO_DEV (DATA.TEXT,dvInfo)

		SEND_STRING 0,"13,10"
		printDEVICE_INFO (dvDEBUG,"",dvInfo)
      }
      // 'SEND ASCII TO DEBUG' EXAMPLE
	  // DEV_TO_STRING EXAMPLE
      CASE 'DEBUG ASC':
      {
        SEND_STRING vdvDEBUG,"13,10"
//        CALL 'SEND ASCII TO DEBUG' (vdvDEBUG,"DEV_TO_STRING(DATA.DEVICE),' ARRAY: '",sARRAY,0,0)
//        CALL 'SEND ASCII TO DEBUG' (vdvDEBUG,"DEV_TO_STRING(DATA.DEVICE),' ASCII: '",sASCII,0,0)
        printToDebug (vdvDEBUG,"DEV_TO_STRING(DATA.DEVICE),' ARRAY: '",sARRAY,0,0,PRINT_ASCII_EXT)
        printToDebug (vdvDEBUG,"DEV_TO_STRING(DATA.DEVICE),' ASCII: '",sASCII,0,0,PRINT_ASCII_EXT)
      }
      // 'SEND ITOHEX TO DEBUG' EXAMPLE
	  // DEV_TO_STRING EXAMPLE
      CASE 'DEBUG HEX':
      {
        SEND_STRING vdvDEBUG,"13,10"
//        CALL 'SEND ITOHEX TO DEBUG' (vdvDEBUG,"DEV_TO_STRING(DATA.DEVICE),' ARRAY: '",sARRAY,0,0)
//        CALL 'SEND ITOHEX TO DEBUG' (vdvDEBUG,"DEV_TO_STRING(DATA.DEVICE),' ASCII: '",sASCII,0,0)
        printToDebug (vdvDEBUG,"DEV_TO_STRING(DATA.DEVICE),' ARRAY: '",sARRAY,0,0,PRINT_HEX)
        printToDebug (vdvDEBUG,"DEV_TO_STRING(DATA.DEVICE),' ASCII: '",sASCII,0,0,PRINT_HEX)
      }
      // 'SEND DECIMAL TO DEBUG' EXAMPLE
	  // DEV_TO_STRING EXAMPLE
      CASE 'DEBUG DEC':
      {
        SEND_STRING vdvDEBUG,"13,10"
//        CALL 'SEND DECIMAL TO DEBUG' (vdvDEBUG,"DEV_TO_STRING(DATA.DEVICE),' ARRAY: '",sARRAY,0,0)
//        CALL 'SEND DECIMAL TO DEBUG' (vdvDEBUG,"DEV_TO_STRING(DATA.DEVICE),' ASCII: '",sASCII,0,0)
        printToDebug (vdvDEBUG,"DEV_TO_STRING(DATA.DEVICE),' ARRAY: '",sARRAY,0,0,PRINT_DECIMAL)
        printToDebug (vdvDEBUG,"DEV_TO_STRING(DATA.DEVICE),' ASCII: '",sASCII,0,0,PRINT_DECIMAL)
      }
      // 'SEND ASCII HEX TO DEBUG' EXAMPLE
      CASE 'DEBUG 7BIT':
      {
        SEND_STRING vdvDEBUG,"13,10"
	  // DEV_TO_STRING EXAMPLE
//        CALL 'SEND ASCII/HEX TO DEBUG' (vdvDEBUG,"DEV_TO_STRING(DATA.DEVICE),' ARRAY: '",sARRAY,0,0)
//        CALL 'SEND ASCII/HEX TO DEBUG' (vdvDEBUG,"DEV_TO_STRING(DATA.DEVICE),' ASCII: '",sASCII,0,0)
        printToDebug (vdvDEBUG,"DEV_TO_STRING(DATA.DEVICE),' ARRAY: '",sARRAY,0,0,PRINT_ASCII_HEX)
        printToDebug (vdvDEBUG,"DEV_TO_STRING(DATA.DEVICE),' ASCII: '",sASCII,0,0,PRINT_ASCII_HEX)

      }
	  // 'SEND INTEGER TO DEBUG' EXAMPLE
      CASE 'DEBUG INT':
      {
        SEND_STRING vdvDEBUG,"13,10"
	  // DEV_TO_STRING EXAMPLE
//        CALL 'SEND INTEGER TO DEBUG' (vdvDEBUG,"DEV_TO_STRING(DATA.DEVICE),' ARRAY: '",sARRAY,0,0)
//        CALL 'SEND INTEGER TO DEBUG' (vdvDEBUG,"DEV_TO_STRING(DATA.DEVICE),' ASCII: '",sASCII,0,0)
        printToDebug (vdvDEBUG,"DEV_TO_STRING(DATA.DEVICE),' ARRAY: '",sARRAY,0,0,PRINT_UNFORMATTED)
        printToDebug (vdvDEBUG,"DEV_TO_STRING(DATA.DEVICE),' ASCII: '",sASCII,0,0,PRINT_UNFORMATTED)
      }
    }
  }
                                    // Terminal string tests
  STRING:                           // SEND S <device num:port:sys>,"<some string>"<enter>
  {
    // 'SEND 131 BYTE PACKETS TO MASTER' EXAMPLE
	printToDebug (dvDEBUG,"","'SEND 131 Test -> ',DATA.TEXT",131,0,PRINT_UNFORMATTED)

    // 'SEND ASCII TO MASTER' EXAMPLE
	// DEV_TO_STRING EXAMPLE
	printToDebug (dvDEBUG,"DEV_TO_STRING(DATA.DEVICE),' ASCII    -> '",DATA.TEXT,0,0,PRINT_ASCII_EXT)

    // 'SEND ITOHEX TO MASTER' EXAMPLE
	// DEV_TO_STRING EXAMPLE
	printToDebug (dvDEBUG,"DEV_TO_STRING(DATA.DEVICE),' HEX      -> '",DATA.TEXT,0,0,PRINT_HEX)

    // 'SEND ASCII TO DEBUG' EXAMPLE
	// DEV_TO_STRING EXAMPLE
	printToDebug (vdvDEBUG,"DEV_TO_STRING(DATA.DEVICE),' ASCII    -> '",DATA.TEXT,131,0,PRINT_ASCII_EXT)

    // 'SEND ITOHEX TO DEBUG' EXAMPLE
	// DEV_TO_STRING EXAMPLE
	printToDebug (vdvDEBUG,"DEV_TO_STRING(DATA.DEVICE),' HEX      -> '",DATA.TEXT,131,0,PRINT_HEX)

    // 'SEND DECIMAL TO DEBUG' EXAMPLE
	// DEV_TO_STRING EXAMPLE
	printToDebug (vdvDEBUG,"DEV_TO_STRING(DATA.DEVICE),' DEC      -> '",DATA.TEXT,131,0,PRINT_DECIMAL)

    // 'SEND 7BIT ASCII TO DEBUG' EXAMPLE
    printToDebug (vdvDEBUG,"DEV_TO_STRING(DATA.DEVICE),' 7BIT ASC -> '",DATA.TEXT,131,0,PRINT_ASCII_HEX)
  }
}

DATA_EVENT[vdvDEBUG]                // this data event could be on another system...
{
  STRING:
  {
    SEND_STRING 0:0:0,DATA.TEXT    // send data to local master
  }
}

(***********************************************************)
(*            THE ACTUAL PROGRAM GOES BELOW                *)
(***********************************************************)
DEFINE_PROGRAM

(***********************************************************)
(*                     END OF PROGRAM                      *)
(*        DO NOT PUT ANY CODE BELOW THIS COMMENT           *)
(***********************************************************)

